/* GeorgeController - controller for george

   Copyright (C), 2002 Adam Fedor.

   Written By: Adam Fedor
   Date: Feb 2002

 */

#include "GeorgeController.h"

@implementation GeorgeController

- init
{
  return [self initWithName: @"George"];
}

- initWithName: (NSString *)myName
{
  [super init];
  ASSIGN(name, myName);
  [self setupConnectionAsServer: ([name isEqual: @"Server"])];
  return self;
}

- (void) dealloc
{
  RELEASE(name);
  RELEASE(timer);
  RELEASE(server);
}

- setupConnectionAsServer: (BOOL)aServer
{
  isServer = aServer;

  if (isServer)
    {
      NSConnection *connect;
      connect = [NSConnection defaultConnection];
      [connect setRootObject: self];
      if (![connect registerName:@"GeorgeServer"])
	{
	  NSLog (@"Could not register us as GeorgeServer");
	  exit (1);
	}
    }
  else
    {
      server = (id <George>)[NSConnection
		 rootProxyForConnectionWithRegisteredName: @"GeorgeServer" 
			                             host: @"*"];
      RETAIN(server);
      timer = [NSTimer scheduledTimerWithTimeInterval: 3
                   target: self
                   selector: @selector(updateLocation:)
                   userInfo: nil
                   repeats: YES];
      RETAIN (timer);
      location = NSMakePoint(0,0);
      srand48(1);
    }
  return self;
}

- (void) updateLocation: sender
{
  NSDictionary *dict;
  /* Move to a random location */
  location = NSMakePoint(800 * drand48(),800 * drand48());
  dict = [NSDictionary dictionaryWithObjectsAndKeys: name, @"Name",
		       [NSValue valueWithPoint: location], @"Location", nil];
  [server hereIAm: dict];
}

- (void) hereIAm: (NSDictionary *)dict
{
  NSLog(@"--------------------------------------------------");
  NSLog(@"Got a message from %@", [dict objectForKey: @"Name"]);
  NSLog(@"He is at %@", 
	NSStringFromPoint([[dict objectForKey: @"Location"] pointValue]));
}

@end

