/* NotGeorgeController - controller for not george

   Copyright (C), 2002 Adam Fedor.

   Written By: Adam Fedor
   Date: Feb 2002

 */

#include "NotGeorgeController.h"

@implementation NotGeorgeController

- init
{
  return [self initWithName: @"NotGeorge"];
}

- initWithName: (NSString *)myName
{
  NSNotificationCenter *not;
  [super init];
  ASSIGN(name, myName);

  not = [NSDistributedNotificationCenter defaultCenter];
  [not addObserver: self
       selector: @selector(hereIAm:)
       name: @"HereIAmNotification"
       object: nil];

  timer = [NSTimer scheduledTimerWithTimeInterval: 3
                   target: self
                   selector: @selector(updateLocation:)
                   userInfo: nil
                   repeats: YES];
  RETAIN (timer);
  location = NSMakePoint(0,0);
  srand48(1);
  return self;
}

- (void) dealloc
{
  RELEASE(name);
  RELEASE(timer);
}

- (void) updateLocation: sender
{
  NSNotificationCenter *not;
  NSDictionary *dict;
  /* Move to a random location */
  location = NSMakePoint(800 * drand48(),800 * drand48());
  dict = [NSDictionary dictionaryWithObjectsAndKeys: name, @"Name",
		       [NSValue valueWithPoint: location], @"Location", nil];

  not = [NSDistributedNotificationCenter defaultCenter];
  [not postNotificationName: @"HereIAmNotification"
	 object: name
         userInfo: dict];
}

- (void) hereIAm: (NSNotification *)not
{
  NSDictionary *dict = [not userInfo];
  if ([[not object] isEqual: name])
    return;

  NSLog(@"--------------------------------------------------");
  NSLog(@"Got a message from %@", [not object]);
  NSLog(@"He is at %@", 
	NSStringFromPoint([[dict objectForKey: @"Location"] pointValue]));
}

@end

